<!DOCTYPE html>
<html lang="EN">

{% set filter = dict({"siteName": ["like",site]}) %}
{% set ipf = client() %}
{% set interface_types = [{"name": "1 Gig Ports", "value": 1000000000}, {"name": "10 Gig Ports", "value": 10000000000}, {"name": "25 Gig Ports", "value": 25000000000}, {"name": "50 Gig Ports", "value": 50000000000}, {"name": "100 Gig Ports", "value": 100000000000}] %}


<head>
    <meta charset="utf-8">
    <title>IPF Report</title>
</head>

<body>
    <!-- First page content -->
    <br><br>
    <div class="logo">
        <img alt="IP Fabric logo" src="{{ logo_url }}" />
    </div>
    <div class="main-title">
        <h1>Interface Usage Report</h1>
    </div>

    <!-- Second page content -->
    <div class="container">
        <div class="section-1">
            <div class="icon-container">
                <div class="section-title"> IP Fabric Interface Report{% if site %} - Site {{ site }} {% endif %}</div>
            </div>
            <div>
                The IP Fabric data report presents interface usage reports based on interface type.
            </div>
        </div>
        <div class="main-title-container">
            <div class="numbers">1</div>
            <h2 class="main-titles">Interfaces in Use</h2>
        </div>
        {% if site %}
            {% set total_used_interfaces = ipf.inventory.interfaces.count(filters={"siteName": ["eq", site], "l1": ["like","up"]}) %}
        {% else %}
            {% set total_used_interfaces = ipf.inventory.interfaces.count(filters={"l1": ["like","up"]}) %}
        {% endif  %}
        <table>
            <tr>
                {% for item in interface_types %}
                <th>{{ item.name }}</th>
                {% endfor %}
                <th>Total Used Interfaces</th>
            </tr>
            <tr>
                {% for item in interface_types %}
                    {% set filter = {"l1": ["like","up"],"speedValue": ["eq",item.value]} %}
                    {% if site %}
                        {% set _ = filter.update({"siteName": ["eq",site]}) %}
                    {% endif %}
                    <td>{{ ipf.inventory.interfaces.count(filters=filter) }}</td>
                {% endfor %}
                <td>{{ total_used_interfaces }}</td>
            </tr>
        </table>
        <div class="main-title-container">
            <div class="numbers">3</div>
            <h2 class="main-titles">Max HW Capacity</h2>
        </div>
        {% if site %}
            {% set total_max_capacity = ipf.inventory.interfaces.count(filters={"siteName": ["eq", site]}) %}
        {% else %}
            {% set total_max_capacity = ipf.inventory.interfaces.count() %}
        {% endif  %}
        <table>
            <tr>
                {% for item in interface_types %}
                <th>{{ item.name }}</th>
                {% endfor %}
                <th>Total Max Capacity</th>
            </tr>
            <tr>
                {% for item in interface_types %}
                    {% set filter = {"speedValue": ["eq",item.value]} %}
                    {% if site %}
                        {% set _ = filter.update({"siteName": ["eq",site]}) %}
                    {% endif %}
                    <td>{{ ipf.inventory.interfaces.count(filters=filter) }}</td>
                {% endfor %}
                <td>{{ total_max_capacity }}</td>
            </tr>
        </table>
        <div class="main-title-container">
            <div class="numbers">3</div>
            <h2 class="main-titles">Port Usage Percentage</h2>
        </div>
        <table>
            <tr>
                {% for item in interface_types %}
                <th>{{ item.name }}</th>
                {% endfor %}
                <th>Total Used Ports</th>
            </tr>
            <tr>
                {% for item in interface_types %}
                    {% set filter = {"speedValue": ["eq",item.value]} %}
                    {% if site %}
                        {% set _ = filter.update({"siteName": ["eq",site]}) %}
                    {% endif %}
                    <td>{{ (ipf.inventory.interfaces.count(filters=filter) / total_max_capacity * 100) | round(2) }}%</td>
                {% endfor %}
                <td>{{ ((total_used_interfaces / total_max_capacity) * 100) | round(2) }}%</td>
            </tr>
        </table>
    </div>
</body>

</html>
